indexing
	cluster: "demangler"
	namespace: "candidate"
	description: "Report errors in a `SYNCHRONISED_DIRECTORY' object."
	original_author: "Justin Finnerty"
	original_date: "July 2005"
	current_date: "$Date: 2005/09/30 06:49:12 $"
	current_author: "$Author: finnerty $"
	revision: "$Revision: 2.2 $"	
	-- $Log: dedup_report.e,v $
	-- Revision 2.2  2005/09/30 06:49:12  finnerty
	-- Finalised for alpha release with SE and VE compilers
	--
	-- Revision 2.1  2005/09/27 06:14:46  finnerty
	-- Updated to use GOBO and work with SE and VE
	--
	-- Revision 2.0  2005/08/26 23:31:39  finnerty
	-- == alpha version ==
	--
	-- Revision 1.2  2005/08/24 12:14:22  finnerty
	-- Refactored many features into a new DUPLICATE_REPORT base class.
	--
	-- Revision 1.1  2005/08/21 11:55:31  finnerty
	-- Alpha 1 version
	--
	-- Revision 1.2  2005/08/17 06:43:43  finnerty
	-- Added factory methods for TRANSFORM sub-types.
	--
	-- Revision 1.1  2005/08/16 15:05:32  finnerty
	-- Initial abstract data type for a report ona sync dir
	--

class DEDUP_REPORT
	-- Report errors in a `SYNCHRONISED_DIRECTORY' object. This report 
	-- searches for backup files that have the same size as the 
	-- original and check whether they have the same content.

inherit
	DUPLICATE_REPORT

creation {ANY}
	make_dedup_report
	
feature {ANY}
	-- Access
	label: UC_STRING is
		once
			!!Result.make_from_utf8 ("Remove duplicated backups")
		end

	help: UC_STRING is
		once
			!!Result.make_from_utf8 ("This report analyses a directory for pairs of files that appear to be an original and backup. If these pairs have identical content then the report marks the backup file for deletion.")
		end

	config_label: STRING is
			-- The label used for this report in the configuration file
		once
			Result := "backup-suffix"
		end
	
feature {DUPLICATE_REPORT}
	-- Creation method
	make_dedup_report (a_sync_dir: SYNCHRONISED_DIRECTORY) is
			-- Initialise attributes to valid values
		do
			make_duplicate_report (a_sync_dir)
			m_compress_type := Uncompressed
		end

end -- class DEDUP_REPORT
