indexing
	cluster: "demangler"
	namespace: "candidate"
	description: "The purpose of an instance of this class is to descend%
	% detect duplicated directory trees."
	original_author: "Justin Finnerty"
	original_date: "October 2005"
	current_date: "$Date: 2005/10/31 07:18:59 $"
	current_author: "$Author: finnerty $"
	revision: "$Revision: 1.1 $"	
	-- $Log: rp_symlink_command.e,v $
	-- Revision 1.1  2005/10/31 07:18:59  finnerty
	-- Added ability to create symlinks between directories as an alternative to merging. The major changes are in DIRDUP_REPORT with others adding/changing features as required.
	--
	--
class RP_SYMLINK_COMMAND
inherit
	DP_COMMAND

creation {ANY}
	make
	
feature {ANY}
	execute is
		do
			report.new_symlink_transform (from_fso, to_path)
		end
	
feature {NONE}
	make (a_rep: SYNC_REPORT; a_from: FILE_SYSTEM_OBJECT; a_to_path: STRING) is
		require
			a_rep /= Void
			a_from /= Void
			a_to_path /= Void and then not a_to_path.is_empty
		do
			report := a_rep
			from_fso := a_from
			!!to_path.make_from_string (a_to_path)
		end

	report: SYNC_REPORT
			-- Transform factory
	to_path: STRING
			-- Arg for transform factory
	from_fso: FILE_SYSTEM_OBJECT
			-- Arg for transform factory
invariant
	report /= Void
	from_fso /= Void
	to_path /= Void and then not to_path.is_empty
end -- class RP_SYMLINK_COMMAND
